"{ Package: 'stx:libjava' }"

Object subclass:#JavaSourceCodeCache
	instanceVariableNames:'parsedCodes'
	classVariableNames:'parsedCode'
	poolDictionaries:''
	category:'Languages-Java-Support'
!

JavaSourceCodeCache class instanceVariableNames:'instance'

"
 No other class instance variables are inherited by this class.
"
!


!JavaSourceCodeCache class methodsFor:'instance creation'!

new
    instance isNil ifTrue: [ instance := self basicNew initialize ].
    ^ instance

    "Created: / 13-12-2010 / 13:56:31 / Jan Kurs <kurs.jan@post.cz>"
! !

!JavaSourceCodeCache methodsFor:'adding & removing'!

flush
    self parsedCodes removeAll.

    "Created: / 17-12-2010 / 16:32:49 / Jan Kurs <kurs.jan@post.cz>"
! !

!JavaSourceCodeCache methodsFor:'initialize'!

initialize
    parsedCodes := IdentityDictionary new.

    "Created: / 13-12-2010 / 14:11:49 / Jan Kurs <kurs.jan@post.cz>"
    "Modified: / 17-12-2010 / 13:35:36 / Jan Kurs <kurs.jan@post.cz>"
! !

!JavaSourceCodeCache methodsFor:'private - searching'!

findMethodLine: javaMethod inMethods: methods 
    | bestMatchMethod  pos |

    pos := javaMethod firstInstructionLineNumber.
    bestMatchMethod := Plug new respondTo: #startLine with: [^ 0].
    methods do: [
        :method | 
        method startLine > pos ifTrue: [
            ^ bestMatchMethod startLine
        ].
        bestMatchMethod := method.
    ].
    ^ 0.

    "Created: / 08-01-2011 / 16:10:37 / Jan Kurs <kurs.jan@post.cz>"
!

getMethodsFor:class 
    ^ parsedCodes at: class fullName ifAbsentPut: [
        [        
            JavaParser methodsIn: class source 
        ] on: Exception do:
        [
            OrderedCollection new.
        ]
    ].

    "Created: / 08-01-2011 / 16:09:47 / Jan Kurs <kurs.jan@post.cz>"
    "Modified: / 07-04-2011 / 22:07:50 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

parsedCodes
    ^ parsedCodes
! !

!JavaSourceCodeCache methodsFor:'queries'!

findLineForMethod:javaMethod inClass:javaClass 
    | methods  mdL |
    methods := self getMethodsFor:javaClass.
    mdL := self findMethodLine:javaMethod inMethods:methods.
    ^ mdL

    "Created: / 13-12-2010 / 13:47:26 / Jan Kurs <kurs.jan@post.cz>"
    "Modified: / 08-01-2011 / 16:10:21 / Jan Kurs <kurs.jan@post.cz>"
! !

!JavaSourceCodeCache class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
